package ga.base;

public class Chromosome {
	boolean[] genotype;
	double fitnessValue;
	
	public Chromosome(int length) {
		genotype = new boolean[length];
	}
	
	public Chromosome(boolean[] gt) {
		genotype = new boolean[gt.length];
		for( int i = 0 ; i < gt.length ; i++ ) {
			genotype[i] = gt[i];
		}
	}
	
	public Chromosome(Chromosome c) {
		genotype = new boolean[c.genotype.length];
		for( int i = 0 ; i < c.genotype.length ; i++ ) {
			genotype[i] = c.genotype[i];
		}
	}
	
	public int length() {
		return genotype.length;
	}
	
	public boolean getGeneAtIndex(int i) {
		return genotype[i];
	}
	
	public void setGeneAtIndex(int i, boolean v) {
		genotype[i] = v;
	}
	
	public void randomize() {
		for( int i = 0 ; i < genotype.length ; i++ ) {
			genotype[i] = (int)(Math.random() * 2) == 1 ? true : false; 
		}
	}
	
	public void setFitnessValue(double f) {
		fitnessValue = f;
	}
	
	public double getFitnessValue() {
		return fitnessValue;
	}
}
