package ga.simple;

import ga.base.Chromosome;
import ga.base.Crossover;
import ga.base.Mutation;

public class SimpleOperator implements Mutation, Crossover {

	@Override
	public void crossover(Chromosome a, Chromosome b) {
		int crossoverPoint = (int)(Math.random() * a.length());
		for( int i = crossoverPoint ; i < a.length() ; i++ ) {
			boolean tmp = a.getGeneAtIndex(i);
			a.setGeneAtIndex(i, b.getGeneAtIndex(i));
			b.setGeneAtIndex(i, tmp);
		}
	}

	@Override
	public void mutate(Chromosome c, double rate) {
		for( int i = 0 ; i < c.length() ; i++ ) {
			if( Math.random() < rate ) {
				boolean newVal = (c.getGeneAtIndex(i) == true) ? false : true;
				c.setGeneAtIndex(i, newVal);
			}
		}
	}
}
