package ga.solver.equation;

import ga.base.Chromosome;
import ga.base.Evaluator;

public class Problem implements Evaluator {
	
	@Override
	public double evaluate(Chromosome c) {
		double v = decode(c);
		double f = eq(v);
		return (f + 15.0);
	}
	
	private double eq(double x) {
		return -2 * x * x + 3 * x - 1;
	}

	public double decode(Chromosome c) {
		double v   = 0;
		double max = 0;
		for( int i = 0 ; i < c.length() ; i++ ) {
			v   = v   * 2 + ((c.getGeneAtIndex(i) == true) ? 1 : 0);
			max = max * 2 + 1;
 		}
		return (4.0 * (double)v / (double)max - 2.0); // real value between -2.0 and 2.0
	}
}
