package ga.solver.equation;

import ga.base.Population;
import ga.simple.SimpleOperator;

public class Solver {
	
	Problem problem;
	Population pop;
	
	public Solver(int populationSize, int chromosomeLength, double mutationRate, double crossoverRate) {
		problem = new Problem();
		pop = new Population(populationSize, chromosomeLength, problem);

		SimpleOperator op = new SimpleOperator();
		pop.setMutationOperation(op, mutationRate);
		pop.setCrossoverOperation(op, crossoverRate);
	}

	public void doSimulation(int generation) {
		pop.randomize();
		System.out.printf("[%d] AVG:%f MAX:%f (%f)\n",
				pop.getGeneration(),
				pop.getAverageFitnessValue(),
				pop.getMaxFitnessValue(),
				problem.decode(pop.getChromosomeWithMaxFitnessValue()));
		for( int i = 0 ; i < generation ; i++ ) {
			pop.update();
			if( pop.getGeneration() % 100 == 0 ) {
				System.out.printf("[%d] AVG:%f MAX:%f (%f)\n",
						pop.getGeneration(),
						pop.getAverageFitnessValue(),
						pop.getMaxFitnessValue(),
						problem.decode(pop.getChromosomeWithMaxFitnessValue()));
			}
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Solver solver = new Solver(100, 100, 0.05, 0.4);
		solver.doSimulation(5000);
	}

}
