package ga.solver.knapsack;

import ga.base.Chromosome;
import ga.base.Evaluator;

public class Problem implements Evaluator {

	int[][] items = { // {Value, Weight}
			{7,10}, {2, 4}, {9, 5}, {4, 1},
			{9, 7}, {7, 3}, {4, 6}, {5, 3}, 
			{3, 7}, {5, 3}, {2, 6}, {1, 3}, 
			{9, 9}, {1, 3}, {2, 1}, {2, 2}, 
			{7,10}, {2, 4}, {9, 5}, {4, 1},
			{9, 7}, {7, 3}, {4, 6}, {5, 3}, 
			{3, 7}, {5, 3}, {2, 6}, {1, 3}, 
			{9, 9}, {1, 3}, {2, 1}, {2, 2}, 
	};
	
	int weightLimit = 30;
	
	@Override
	public double evaluate(Chromosome c) {
		int v = 0, w = 0;
		for( int i = 0 ; i < items.length ; i++ ) {
			if(c.getGeneAtIndex(i) == true) {
				v += items[i][0];
				w += items[i][1];
			}
		}
		if( weightLimit < w ) {
			v = 0;
		}
		return v;
	}
	
	public int getItemsNum() {
		return items.length;
	}
	
	public String makeString(Chromosome c) {
		String s = "";
		for( int i = 0 ; i < c.length() ; i++ ) {
			if(c.getGeneAtIndex(i) == true ) {
				s += "[" + items[i][0] + "," + items[i][1] + "]";
			}
		}
		return s;
	}
}