package ga.solver.knapsack;

import ga.base.Population;
import ga.simple.SimpleOperator;

public class Solver {
	
	Problem problem;
	Population pop;
	
	public Solver(Problem prob, int populationSize, double mutationRate, double crossoverRate) {
		problem = prob;
		pop = new Population(populationSize, problem.getItemsNum(), problem);

		SimpleOperator op = new SimpleOperator();
		pop.setMutationOperation(op, mutationRate);
		pop.setCrossoverOperation(op, crossoverRate);
	}

	public void doSimulation(int generation) {
		pop.randomize();
		System.out.printf("[%d] AVG:%f MAX:%f %s\n",
				pop.getGeneration(),
				pop.getAverageFitnessValue(),
				pop.getMaxFitnessValue(),
				problem.makeString(pop.getChromosomeWithMaxFitnessValue()));
		for( int i = 0 ; i < generation ; i++ ) {
			pop.update();
			if( pop.getGeneration() % 100 == 0 ) {
				System.out.printf("[%d] AVG:%f MAX:%f %s\n",
						pop.getGeneration(),
						pop.getAverageFitnessValue(),
						pop.getMaxFitnessValue(),
						problem.makeString(pop.getChromosomeWithMaxFitnessValue()));
			}
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Solver solver = new Solver(new Problem(), 1000, 0.01, 0.4);
		solver.doSimulation(5000);
	}

}
